/*
 * Copyright (C) 1999, David Luyer and the University of Western Australia
 *
 * This file is released under the GNU General Public License.
 * Please read the file "COPYING" for license information.
 * If you did not receive the file "COPYING" with this file, a copy is
 * available by e-mail from David Luyer <luyer@ucs.uwa.edu.au>.
 */
#include <stdio.h>
#include <sys/unistd.h>
#include <sys/types.h>

extern char input_char;
extern int keep_running;
extern char *shm_ptr;

extern void **user_data;
extern int user_data_version;

void process_input() {
  switch (user_data_version) {
  case 0:
    user_data = NULL;
    user_data_version = 1;
    printf("Dummy client ready.  Press 'q' to quit or 'd' to dump shared memory.\n");
    return;
  case 1:
    break;
  default:
    printf("Unknown user data version.  Aborting.\n");
    keep_running = 0;
    break;
  }
  if(input_char == 'q') {
    printf("Quitting ('q' found).\n");
    keep_running = 0;
  } else if(input_char == 'd') {
    write(1, shm_ptr + sizeof(int) + sizeof(off_t), *(off_t *)(shm_ptr + sizeof(int)));
  } else {
    printf("Got '%c'; press 'q' to quit or 'd' to dump shared memory.\n", input_char);
  }
}
